<template>
  <v-row justify="center">
    <v-dialog
      v-model="usersManage.open"
      @keydown.esc="handleClose"
      @click:outside="handleClose"
      width="800px"
    >
      <v-card>
        <v-toolbar style="position:relative" color="white" elevation="0">
          <v-spacer />
          <v-toolbar-title class="mt-5">
            <span class="primary--text">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-notebook-edit</v-icon
              ><b>Gerenciar entidades do usuário</b>
            </span>
          </v-toolbar-title>
          <v-spacer />
          <v-tooltip color="red" bottom>
            <template v-slot:activator="{ on }">
              <v-icon
                v-on="on"
                style="position:absolute; right: 15px"
                color="red"
                @click="handleClose"
                >mdi-close</v-icon
              >
            </template>
            <span><b>Fechar</b> janela</span>
          </v-tooltip>
        </v-toolbar>
        <v-card-text class="scrollForm">
          <v-form ref="form" v-model="valid">
            <v-container>
              <p style="padding: 0px; margin: 0px">
                <b>Nome: </b>{{ user.name }} {{ user.surname }}
              </p>
              <p style="padding: 0px; margin: 0px"><b>Matrícula: </b>{{ user.matriculation }}</p>
              <p style="padding: 0px; margin: 0px"><b>E-mail: </b>{{ user.email }}</p>
              <v-row>
                <v-col cols="12" md="12">
                  <v-row>
                    <v-col cols="5">
                      <span class="subtitle-1 font-weight-bold">Entidade</span>
                    </v-col>
                    <v-col cols="5">
                      <span class="subtitle-1 font-weight-bold">Papel na entidade</span>
                    </v-col>
                    <v-col cols="2">
                      <span class="subtitle-1 font-weight-bold">Ações</span>
                    </v-col>
                    <v-col cols="12">
                      <v-divider></v-divider>
                    </v-col>
                    <!-- Percorre o userRoles para mostrar entidades -->
                    <v-col v-for="(userRole, index) in userRoles" :key="index" cols="12">
                      <!-- Clica para editar a entidade -->
                      <v-row style="position: relative" v-if="editingIndex == index">
                        <!-- Resultado da pesquisa entidade -->

                        <v-col
                          v-if="searchClean && allEntities.length > 0"
                          cols="12"
                          class="pa-0 my-0 ml-3"
                        >
                          EDITANDO
                          <span v-if="searchClean && allEntities.length > 0">
                            Existem
                            <b>{{ allEntities.length }}</b> entidades selecionáveis.
                          </span>
                          <span v-if="selectedEntityName">
                            <br />
                            <b>{{ selectedEntityName }}</b>
                            <v-icon class="ml-1" color="green" x-small>mdi-check</v-icon>
                          </span>
                        </v-col>
                        <!-- Fim resultado pesquisa entidade -->
                        <v-col cols="5">
                          <v-row no-gutters align="center">
                            <v-autocomplete
                              disabled
                              class="pr-2"
                              v-model="editedEntity.entity"
                              :search-input.sync="entityToSearch"
                              :label="result"
                              solo-inverted
                              flat
                              hide-no-data
                              hide-details
                              :items="allEntities"
                              item-text="name"
                              item-value="id"
                              @change="showSelected(editedEntity.entity)"
                            ></v-autocomplete>
                          </v-row>
                        </v-col>
                        <v-col cols="5">
                          <v-autocomplete
                            v-model="editedEntity.privileges"
                            label="Selecione um papel"
                            solo-inverted
                            flat
                            hide-no-data
                            hide-details
                            :items="allPrivileges"
                            item-text="label"
                            item-value="id"
                          ></v-autocomplete>
                        </v-col>
                        <v-col cols="1">
                          <v-tooltip bottom>
                            <template v-slot:activator="{ on }">
                              <v-btn
                                :disabled="!editedEntity.entity || !editedEntity.privileges"
                                icon
                                small
                                color="primary"
                                class="mt-2"
                                v-on="on"
                                @click="
                                  confirmEdit(index, editedEntity.entity, editedEntity.privileges)
                                "
                              >
                                <v-icon color="success">mdi-check</v-icon>
                              </v-btn>
                            </template>
                            <span>Confirmar edição</span>
                          </v-tooltip>
                        </v-col>
                        <v-col cols="1">
                          <v-tooltip bottom>
                            <template v-slot:activator="{ on }">
                              <v-btn
                                icon
                                small
                                color="primary"
                                class="mt-2"
                                v-on="on"
                                @click="cancelEdit"
                              >
                                <v-icon color="error">mdi-close</v-icon>
                              </v-btn>
                            </template>
                            <span>Cancelar edição</span>
                          </v-tooltip>
                        </v-col>
                      </v-row>
                      <!-- Fim clica para editar entidade -->
                      <!-- /// -->
                      <!-- Mostra a entidade se não estiver editando -->
                      <v-row v-if="editingIndex !== index">
                        <v-col cols="5">
                          <span class="subtitle-1">{{ userRole.entity.name }}</span>
                        </v-col>
                        <v-col cols="5">
                          <span class="subtitle-1">{{ userRole.privileges.label }}</span>
                        </v-col>
                        <v-col cols="1">
                          <v-tooltip bottom>
                            <template v-slot:activator="{ on }">
                              <v-btn
                                icon
                                small
                                color="primary"
                                :disabled="editing"
                                v-on="on"
                                @click="editEntity(userRole, index)"
                              >
                                <v-icon color="primary">mdi-pencil</v-icon>
                              </v-btn>
                            </template>
                            <span>Editar entidade/papel</span>
                          </v-tooltip>
                        </v-col>
                        <v-col align="center" class="px-0 ml-n4" cols="1" style="positon: relative">
                          <v-tooltip
                            bottom
                            :disabled="confirmDelete && index == confirmDeleteIndex"
                          >
                            <template v-slot:activator="{ on }">
                              <v-btn
                                icon
                                small
                                color="primary"
                                :disabled="editing"
                                v-on="on"
                                @click="removeEntity(index)"
                              >
                                <v-icon color="primary">mdi-delete</v-icon>
                              </v-btn>
                            </template>
                            <span>Remover entidade/papel</span>
                          </v-tooltip>
                          <div
                            v-if="confirmDelete && index == confirmDeleteIndex"
                            style="position: absolute"
                          >
                            <b>Remover?</b>
                            <p>
                              <span
                                @click="confirmRemoveEntity(index)"
                                @mouseenter="mouseEnter = true"
                                @mouseleave="mouseEnter = false"
                                :style="
                                  mouseEnter && 'font-weight:bold;cursor:pointer; color: seagreen'
                                "
                                >Sim</span
                              >
                              |
                              <span
                                @click="cancelRemoveEntity"
                                @mouseenter="mouseEnter2 = true"
                                @mouseleave="mouseEnter2 = false"
                                :style="
                                  mouseEnter2 && 'font-weight:bold;cursor:pointer; color: red'
                                "
                                >Não</span
                              >
                            </p>
                          </div>
                        </v-col>
                      </v-row>
                    </v-col>
                    <!-- Mostra caixa de Adicionar nova Entidade -->
                    <v-col cols="12">
                      <v-row style="position: relative" v-if="addingEntity">
                        <!-- Resultado da pesquisa entidade -->
                        <v-col
                          v-if="searchClean && allEntities.length > 0"
                          cols="12"
                          class="pa-0 my-0 ml-3"
                        >
                          <span v-if="searchClean && allEntities.length > 0">
                            Existem
                            <b>{{ allEntities.length }}</b> entidades selecionáveis.
                          </span>
                          <span v-if="selectedEntityName">
                            <br />
                            <b>{{ selectedEntityName }}</b>
                            <v-icon class="ml-1" color="green" x-small>mdi-check</v-icon>
                          </span>
                        </v-col>
                        <!-- Fim resultado pesquisa entidade -->
                        <v-col cols="6">
                          <v-row no-gutters align="center">
                            <v-autocomplete
                              style="max-width: 90%"
                              class="pr-2"
                              v-model="editedEntity.entity"
                              :search-input.sync="entityToSearch"
                              :label="result"
                              solo-inverted
                              flat
                              hide-no-data
                              hide-details
                              :items="allEntities"
                              item-text="name"
                              item-value="id"
                              @change="showSelected(editedEntity.entity)"
                            ></v-autocomplete>
                            <!-- <v-tooltip v-if="!searchClean" bottom>
                              <template v-slot:activator="{ on }">
                                <v-btn
                                  v-on="on"
                                  :disabled="entityToSearch == null || entityToSearch.length == 0"
                                  color="primary"
                                  fab
                                  small
                                  @click="searchEntities(entityToSearch)"
                                >
                                  <v-icon small>mdi-magnify</v-icon>
                                </v-btn>
                              </template>
                              <span>Buscar por entidade</span>
                            </v-tooltip>
                            <v-tooltip v-else bottom>
                              <template v-slot:activator="{ on }">
                                <v-btn
                                  v-on="on"
                                  v-if="searchClean"
                                  fab
                                  small
                                  icon
                                  @click="cleanSearch"
                                >
                                  <v-icon color="red" @click="cleanSearch"
                                    >mdi-magnify-minus-outline</v-icon
                                  >
                                </v-btn>
                              </template>
                              <span>Limpar busca entidade</span>
                            </v-tooltip> -->
                          </v-row>
                        </v-col>
                        <v-col cols="4">
                          <v-autocomplete
                            v-model="editedEntity.privileges"
                            label="Selecione um papel"
                            solo-inverted
                            flat
                            hide-no-data
                            hide-details
                            :items="allPrivileges"
                            item-text="label"
                            item-value="id"
                          ></v-autocomplete>
                        </v-col>
                        <v-col cols="1">
                          <v-tooltip bottom>
                            <template v-slot:activator="{ on }">
                              <v-btn
                                :disabled="!editedEntity.entity || !editedEntity.privileges"
                                icon
                                small
                                color="primary"
                                class="mt-2"
                                v-on="on"
                                @click="addToEntities(editedEntity.entity, editedEntity.privileges)"
                              >
                                <v-icon color="success">mdi-check</v-icon>
                              </v-btn>
                            </template>
                            <span>Confirmar</span>
                          </v-tooltip>
                        </v-col>
                        <v-col cols="1">
                          <v-tooltip bottom>
                            <template v-slot:activator="{ on }">
                              <v-btn
                                icon
                                small
                                color="primary"
                                class="mt-2"
                                v-on="on"
                                @click="cancelAddEntity"
                              >
                                <v-icon color="error">mdi-close</v-icon>
                              </v-btn>
                            </template>
                            <span>Cancelar</span>
                          </v-tooltip>
                        </v-col>
                      </v-row>
                      <v-row no-gutters>
                        <v-col cols="12" align="center">
                          <v-btn color="primary" outlined :disabled="editing" @click="addEntity">
                            Adicionar Entidade
                          </v-btn>
                        </v-col>
                        <v-col v-if="success" cols="12" class="pt-5 pl-3" align="center">
                          <span v-html="successMessage" />
                          <v-icon color="green" class="ml-2" small>mdi-check</v-icon>
                        </v-col>
                      </v-row>
                    </v-col>
                  </v-row>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>
        <v-card-actions class="mt-n3 pb-6 pr-6">
          <v-spacer></v-spacer>
          <v-btn color="lighter" text @click="handleClose">Cancelar</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import User from '../../services/user'
import Management from '../../services/management'

export default {
  name: 'UsersManage',
  props: {
    user: { type: Object },
  },
  components: {},
  data: () => ({
    updateHimself: false,
    valid: false,
    confirmDelete: false,
    confirmDeleteIndex: -1,
    mouseEnter: false,
    mouseEnter2: false,
    editing: false,
    addingEntity: false,
    editingIndex: -1,
    editedEntity: {
      entity: '',
      privileges: '',
    },
    entityToSearch: '',
    selectedEntityName: '',
    searchClean: false,
    label: {
      initial: 'Por favor, digite o nome da entidade para buscar',
      noResult: 'Desculpe, nenhuma entidade encontrada',
      result: 'Selecione a entidade',
    },
    result: 'Por favor, digite o nome da entidade para buscar',
    userRoles: [],
    allPrivileges: [],
    allEntities: [],
    success: false,
    successMessage: '',
    successMessageContent: {
      add: 'Entidade <b><span style="color: seagreen">adicionada</span></b> com sucesso!',
      edit: 'Entidade <b>editada</b> com sucesso!',
      del: 'Entidade <b><span style="color: red">deletada</span></b> com sucesso!',
    },
  }),
  computed: {
    ...mapState('user', ['usersManage']),
  },
  watch: {
    usersManage(usersManage) {
      this.userRoles = usersManage.entities.entities
    },
  },
  async created() {
    // this.readEntities()
    this.readPrivileges()
  },
  methods: {
    ...mapMutations('user', ['UPDATE_USERS_MANAGE']),
    cleanSearch() {
      this.searchClean = false
      this.allEntities = []
      this.selectedEntityName = ''
      this.editedEntity.entity = ''
      this.editedEntity.privileges = ''
      this.result = this.label.initial
    },
    showSelected(id) {
      if (this.allEntities.length > 0)
        this.allEntities.forEach((entity) => {
          console.log(entity)
          if (entity.id === id) {
            if (entity.firstName) {
              this.selectedEntityName = entity.firstName + ' / ' + entity.name
              return
            } else {
              this.selectedEntityName = entity.name
              return
            }
          }
        })
    },
    async searchEntities(item) {
      if (!item) {
        item = ''
      }
      this.result = this.label.initial
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('updateEntity').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.readEntityByName(entityId, actionId, item)
        this.allEntities = ret.data
        this.searchClean = true

        if (this.allEntities.length > 0) {
          this.result = this.label.result
        } else {
          this.result = this.label.noResult
        }
      } catch (e) {
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    async readPrivileges() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('readPrivilege').id
      try {
        let ret = await Management.readPrivilege(entityId, actionId)
        if (ret.success) {
          this.allPrivileges = ret.data
        }
      } catch (e) {
        console.log(e)
      }
    },
    async changeRole(entityToChange, newPrivilege) {
      const routedEntity = await this.$getItem('routedEntity')
      const userInfo = await this.$getItem('userInfo')
      const userId = userInfo.id
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userChangePrivilege').id
      let data = {
        id: this.user.id,
        entity: entityToChange,
        privilege: newPrivilege.id,
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.changeUserPrivileges(entityId, actionId, data)
        if (ret.success) {
          //checa se alterou o papel dele mesmo na entidade
          if (userId == this.user.id) {
            this.$emit('updatedHimself')
            this.updateHimself = true
          }
          this.$parent.readUsers()
        }
      } catch (e) {
        console.log(e)
      } finally {
        if (!this.updateHimself) {
          this.$store.commit('user/UPDATE_LOADING', false)
        } else {
          this.handleClose()
        }
      }
      this.updateHimself = false
    },
    handleClose() {
      this.$refs.form.reset()
      this.cleanSearch()
      this.UPDATE_USERS_MANAGE({ open: false, entities: {}, id: '' })
      this.userRoles = []
      this.editing = false
      this.addingEntity = false
      this.confirmDelete = false
      this.confirmDeleteIndex = -1
      this.success = false
      this.successMessage = ''
    },
    async handleCreate() {
      const routedEntity = await this.$getItem('routedEntity')
      let entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userAddOnEntity').id
      const data = {
        id: this.$store.state.user.usersManage.id,
        to: this.editedEntity.entity,
        privileges: this.editedEntity.privileges,
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.addUserOnEntity(entityId, actionId, data)
        if (ret.success) {
          this.success = true
          this.successMessage = this.successMessageContent.add
        }
      } catch (e) {
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    addEntity() {
      this.cleanSearch()
      this.editingIndex = -1
      this.confirmDelete = false
      this.editing = true
      this.addingEntity = true
      this.success = false
      this.successMessage = ''
      this.searchEntities()
    },
    cancelAddEntity() {
      this.editingIndex = -1
      this.editing = false
      this.addingEntity = false
      this.cleanSearch()
    },
    cancelEditing() {
      this.editing = false
      this.addingEntity = false
    },
    addToEntities(entity, privilege) {
      this.editing = false
      this.addingEntity = false
      const selectedEntity = this.allEntities.filter((value) => {
        return value.id === entity
      })[0]
      const selectedPrivilege = this.allPrivileges.filter((value) => {
        return value.id === privilege
      })[0]
      const userRole = {
        entity: selectedEntity,
        privileges: selectedPrivilege,
      }
      this.userRoles.push(userRole)
      this.handleCreate()
    },
    editEntity(entity, index) {
      this.editingIndex = index
      let arrayEdit = []
      arrayEdit.push(entity.entity)
      this.allEntities = arrayEdit
      this.editedEntity.entity = entity.entity.id
      this.editedEntity.privileges = entity.privileges.id
    },

    async confirmEdit(index, entity, privilege) {
      //atualiza na array userRoles e na tela
      let selectedEntity = this.allEntities.filter((value) => {
        return value.id == entity
      })[0]
      let selectedPrivilege = this.allPrivileges.filter((value) => {
        return value.id == privilege
      })[0]

      let editedUserRole = {
        entity: selectedEntity,
        privileges: selectedPrivilege,
      }
      this.userRoles[index] = editedUserRole

      this.changeRole(entity, selectedPrivilege)
      this.success = true
      this.successMessage = this.successMessageContent.edit

      // zera campos
      this.editingIndex = -1
      this.editedEntity.entity = ''
      this.editedEntity.privileges = ''
      this.cleanSearch()
    },
    async refreshAfterEdit() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userRead').id
      const id = this.$store.state.user.usersManage.id
      try {
        let ret = await Management.readUserEntities(entityId, actionId, id)
        console.log(ret, 'apos atualizar')
        if (ret.success) {
          this.success = true
          this.successMessage = this.successMessageContent.edit
        }
      } catch (e) {}
    },
    cancelEdit() {
      this.editedEntity.entity = ''
      this.editedEntity.privileges = ''
      this.editingIndex = -1
      this.cleanSearch()
    },
    removeEntity(index) {
      this.confirmDelete = true
      this.confirmDeleteIndex = index
      this.mouseEnter = false
      this.mouseEnter2 = false
    },
    cancelRemoveEntity(index) {
      this.confirmDelete = false
      this.confirmDeleteIndex = -1
      this.mouseEnter2 = false
    },
    async confirmRemoveEntity(index) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userRemoveFromEntity').id
      const data = {
        id: this.$store.state.user.usersManage.id,
        from: this.userRoles[index].entity.id,
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.removeUserFromEntity(entityId, actionId, data)
        if (ret.success) {
          this.removeEntity(index)
          this.success = true
          this.successMessage = this.successMessageContent.del
          this.userRoles.splice(index, 1)
          this.confirmDelete = false
          this.confirmDeleteIndex = -1
          this.mouseEnter = false
          this.cleanSearch()
          this.$parent.readUsers()
        }
      } catch (e) {
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
  },
}
</script>

<style scoped></style>
